/*
 * RenderThread.java
 *
 * Created on 6 de marzo de 2006, 14:40
 */

package Flier_Match.FMCliente.video;
import java.awt.DisplayMode;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.image.BufferStrategy;

import Flier_Match.FMCliente.sistema.GameLoop;
import Flier_Match.FMCliente.sistema.Lista;
import Flier_Match.FMCliente.sistema.ManejadorEventos;
import Flier_Match.FMCliente.sistema.Parametros;
import Flier_Match.FMCliente.sonido.ManejadorSonidos;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.IRenderer;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.Texture;
import com.threed.jpct.World;
/**
 *
 * @author  Administrador
 * @version 
 */
public class RenderThread extends Thread{

	private float animIndex=0;
	
	public FrameBuffer buffer;
	public Parametros param;
	
	public Texture Color;

    private Lista navesLista;
    
    public Frame renderSW;

    int resolucion [];
    
    private Blitter BM;
    private ManejadorEventos ME;
    
    private Graphics gFrame=null;
    private BufferStrategy bufferStrategy=null;
    private GraphicsDevice device=null;
    
    private int titleBarHeight=0;
    private int leftBorderWidth=0;

    private int vida=1000;
    
    private ManejadorSonidos player;
    
    private boolean enChat=false;
    private String mensajeChat="";
    
    /** Creates new RenderThread */
    public RenderThread(Parametros P, Lista navesLista, World aMenu, World aNaves, World aTrailer, World aSplash, String ahost, int apuerto, ManejadorEventos ame, ManejadorSonidos player) {
        
    	param=P;
        ME=ame;
        
        this.player=player;
        
        resolucion=param.getResolucion ();
        
        param.cargarMapaChars (param.getPath ()+"/CHARMAP.PROP");
        BM=new Blitter (resolucion [0], resolucion [1], param);
        
        /*
        BM.agregarMensajes ("Mensaje 1", 1, 2000);
        BM.agregarMensajes ("oo, es un mensaje de pruebaAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaAAAAAAAAAAAAAAAAAA", 3, 3000);
        BM.agregarMensajes ("!", 3, 4000);
        */
        
        this.navesLista=navesLista;

        if (param.getRender ()==1) {
            //ajustar todo para software rendering
        	GraphicsEnvironment env=GraphicsEnvironment.getLocalGraphicsEnvironment();
            device=env.getDefaultScreenDevice();
            GraphicsConfiguration gc=device.getDefaultConfiguration();
            renderSW=new Frame(gc);
            renderSW.setUndecorated(true);
            renderSW.setIgnoreRepaint(true);
            device.setFullScreenWindow(renderSW);
            if (device.isDisplayChangeSupported()) {
               device.setDisplayMode((new DisplayMode(resolucion [0], resolucion [1], 32, 0)));
            }
            renderSW.createBufferStrategy(2);
            bufferStrategy=renderSW.getBufferStrategy();
            Graphics g=bufferStrategy.getDrawGraphics();
            bufferStrategy.show();
            g.dispose();
            ME.initME (renderSW, 1, player);
        }
        if (param.getRender ()==2) {
        	ME.initME (null, 2, player);
        }
        
        navesLista.separar (400, new SimpleVector (1, 0, 0));
        
        ME.setParametros (param);
        ME.setWorlds (aSplash, aMenu, aNaves, aTrailer);
        ME.setTCP (ahost, apuerto);
        ME.idWorld=1;
        ME.setNavesLista(navesLista);
        
        ME.Menu=aMenu;
        ME.Naves=aNaves;
        ME.Trailer=aTrailer;
        
        ME.start();
    }
    
    public void run () {
        System.out.println ("Iniciando Render");

        int width=(param.getResolucion ())[0];
        int height=(param.getResolucion ())[1];
        buffer=new FrameBuffer (width, height, FrameBuffer.SAMPLINGMODE_NORMAL);
        if (param.getRender ()==2) {
            buffer.enableRenderer (IRenderer.RENDERER_OPENGL);
            buffer.disableRenderer(IRenderer.RENDERER_SOFTWARE);
        }
        else if (param.getRender ()==1) {
            buffer.enableRenderer (IRenderer.RENDERER_SOFTWARE);
            renderSW.show ();
            renderSW.setSize(width, height);
        }
        
        while (!(ME.salida)) {
        	try {
        		Thread.sleep(5);
                
            } catch (Exception E) {
                E.printStackTrace();
            }
            
            if (ME.checkNuevoJugador())ME.agregarJugador();
            if (ME.checkSalidaJugador())ME.removerJugador();
            
            mostrarImagen ();
            //actualCam=Actual.getCamera ();
            //ME.ejecutarComandos ();
            
        }
        
        if (param.getRender ()==2) buffer.disableRenderer (IRenderer.RENDERER_OPENGL);
        if (param.getRender ()==1) buffer.disableRenderer (IRenderer.RENDERER_SOFTWARE);
        
        System.out.println ("Render Thread terminado");
        
        System.exit(0);
    }

    public void mostrarImagen () {
    	World Actual=ME.Actual;
        if (Actual==null || ME.salir) {
        	System.out.println ("\n\n--------El World es nulo");
        	System.exit(1);
        }
        else if (buffer==null) {
        	System.out.println ("\n\n --------El FrameBuffer es nulo");
        	System.exit(1);
        }
        else {
        	
            buffer.clear ();
            buffer.update ();
            if (Actual==ME.Menu) {
            	BM.blitOnCenterScreen(buffer, "");
            } 
            Actual.renderScene (buffer);
            Actual.draw (buffer);
            
            if (Actual==ME.Juego) {
            	if (ME.jugando) {
                    
                    BM.blitBorde (buffer);
                    if (ME.nodoPropio!=null)BM.blitRadar (buffer, ME.jugadores, ME.nodoPropio);
                    BM.blitMira (buffer);
                    if (ME.nodoPropio!=null)BM.blitVida (buffer, ME.nodoPropio.getVida ());
                    BM.BlitTodosMensajes (buffer);
                    
                    try {
                    	vida=ME.nodoPropio.getVida ();
                    } catch (Exception E) {
                    	
                    }
                    BM.blitEnergia(buffer, (vida/10), 80);//----------FALTA AJUSTAR EL NIVEL DE ENERGIA
                    
                    
                    if (enChat){
                    	//System.out.println ("Mostrando el chatField con: "+mensajeChat);
                    	BM.blitChatField(buffer, "CHAT: "+mensajeChat);
                    }
                    
                }
            }
            
            
            if (param.getRender ()==1) {
            	Graphics g=bufferStrategy.getDrawGraphics();
                g.drawImage(buffer.getOutputBuffer(), 0, 0, null);
                bufferStrategy.show();
                g.dispose();

            }else if (param.getRender ()==2) buffer.displayGLOnly ();
        }
    }
    
    public void setEnChat (boolean aEnChat) {
    	enChat=aEnChat;
    	if (enChat==false)System.out.println ("Deteniendo el chat"+enChat);
    }
    
    public void setMensajeChat (String aMensajeChat) {
    	mensajeChat=aMensajeChat;
    	//System.out.println ("MENSAJECHAT En: "+mensajeChat);
    	
    }
    
    /**
     * Aade un mensaje para ser mostrado como chat
     * 
     * @param mensajeParaChat Es el mensaje que se agregar al listado de mensajes a mostrar
     */
    public void addToChat (String mensajeParaChat) {
    	if (mensajeParaChat == null || mensajeParaChat.compareTo("")==0) {
    		
    	} else BM.agregarMensajes(mensajeParaChat, BM.TIPO_CHAT, 3500);//FALTA: HACER QUE EL TIEMPO QUE POERMANEZCA EL MENSAJE LO COJA DE ALGUN PARAMETRO
    }
   
}
